﻿Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Graphics
Imports Microsoft.Xna.Framework.Audio
Imports Microsoft.Xna.Framework.Content
Imports Microsoft.Xna.Framework.Media
Imports Microsoft.Xna.Framework.Input
Imports Microsoft.Xna.Framework.GamerServices


Public Class Game
    Inherits Microsoft.Xna.Framework.Game
    Dim graphics As GraphicsDeviceManager
    Dim SpriteBatch As SpriteBatch

    Dim directed As rotated
    Dim cam As camera
    Dim texture As Texture2D
    Dim back As Texture2D

    


    Public Sub New()
        graphics = New GraphicsDeviceManager(Me)
        Window.Title = "Rocket and stars"
        graphics.PreferredBackBufferWidth = 800
        graphics.PreferredBackBufferHeight = 480
    End Sub

    Protected Overrides Sub Initialize()
        'TODO: Add your initialization logic here'

        MyBase.Initialize()
        

    End Sub
    Protected Overrides Sub LoadContent()
        ' TODO: use this.Content to load your game content here'
        SpriteBatch = New SpriteBatch(GraphicsDevice)
        cam = New camera(graphics.GraphicsDevice.Viewport)
        texture = Content.Load(Of Texture2D)("xnb\rocket")
        back = Content.Load(Of Texture2D)("xnb\star")
        directed = New rotated(texture, 1, New Vector2(50, 50), New Vector2(0, 0), 0, 1)

        MyBase.LoadContent()

    End Sub
    Protected Overrides Sub UnloadContent()
        MyBase.UnloadContent()
        'TODO: Unload any non ContentManager content here'
    End Sub

    Protected Overrides Sub Update(ByVal gameTime As Microsoft.Xna.Framework.GameTime)

        If (Keyboard.GetState.IsKeyDown(Keys.A)) Then
            cam.Rotation += 0.1
        End If

        If (Keyboard.GetState.IsKeyDown(Keys.Z)) Then
            cam.Rotation -= 0.1
        End If

        If (Keyboard.GetState.IsKeyDown(Keys.Add)) Then
            cam.Zoom += 0.1
        End If

        If (Keyboard.GetState.IsKeyDown(Keys.Subtract)) Then
            cam.Zoom -= 0.1
        End If

        'right
        If (Keyboard.GetState.IsKeyDown(Keys.Right)) Then
            directed._Rotation += 3
            If directed._Rotation > 360 Then directed._Rotation -= 360
        End If
        'left
        If (Keyboard.GetState.IsKeyDown(Keys.Left)) Then
            directed._Rotation -= 3
            If directed._Rotation < 0 Then directed._Rotation += 360
        End If
        If (Keyboard.GetState.IsKeyDown(Keys.Up)) Then
            directed._speed = 2
        Else
            directed._speed = 0
        End If

        directed.Update(gameTime)

        cam.setfocalpoint(New Vector2(directed._Position.X, directed._Position.Y), New Vector2(graphics.PreferredBackBufferWidth * 1.5 + texture.Width, graphics.PreferredBackBufferHeight * 1.5 + texture.Height))

        cam.update()


        MyBase.Update(gameTime)

    End Sub

    
    Protected Overrides Sub Draw(ByVal gameTime As Microsoft.Xna.Framework.GameTime)
        SpriteBatch.Begin(SpriteSortMode.Immediate, BlendState.AlphaBlend, Nothing, Nothing, Nothing, Nothing, cam.viewmatrix)

        SpriteBatch.Draw(back, New Vector2(0, 0), Color.White)

        directed.Draw(SpriteBatch)

        SpriteBatch.End()

        MyBase.Draw(gameTime)
    End Sub

End Class

