﻿Imports Microsoft.Xna.Framework
Imports Microsoft.Xna.Framework.Graphics
Imports Microsoft.Xna.Framework.Audio
Imports Microsoft.Xna.Framework.Content
Imports Microsoft.Xna.Framework.Media
Imports Microsoft.Xna.Framework.Input



Public Class rotated
    Public _Texture As Texture2D
    Public _scale As Single
    '
    Public _Position As Vector2
    Public _Direction As Vector2
    Public _origin As Vector2
    Public _Rotation As Single
    Public _speed As Single


    Public Sub New(texture As Texture2D, scale As Single, position As Vector2, direction As Vector2, rotation As Single, Speed As Single)
        Me._Texture = texture
        Me._Position = position
        Me._Direction = direction
        Me._Rotation = rotation
        Me._scale = scale
        Me._speed = Speed
        Me._origin = New Vector2(_Texture.Width / 2, _Texture.Height / 2)
    End Sub

    Public Sub Update(gametime As GameTime)

        _Direction = New Vector2(CSng(Math.Cos(MathHelper.ToRadians(_Rotation))), CSng(Math.Sin(MathHelper.ToRadians(_Rotation))))
        _Direction.Normalize()

        _Position += _Direction * _speed

    End Sub

    Public Sub Draw(spriteBatch As SpriteBatch)

        spriteBatch.Draw(_Texture, _Position, Nothing, Color.White, MathHelper.ToRadians(_Rotation), _origin, _scale, SpriteEffects.None, 0)
    End Sub

End Class
